﻿<%@ Page Title="Home Page" Language="C#" MasterPageFile="~/Site.master" AutoEventWireup="true"
    CodeBehind="Default.aspx.cs" Inherits="igGridRowSelectors._Default" %>

<asp:Content ID="HeaderContent" runat="server" ContentPlaceHolderID="HeadContent">
</asp:Content>
<asp:Content ID="BodyContent" runat="server" ContentPlaceHolderID="MainContent">
    <h2>
        Welcome to ASP.NET!
    </h2>

    <div id="gridHolder">
    <table id="gridTarget"></table>
    </div>

    <div id="holder">
    <img id="boxArt" alt="Select a movie..." src="" align="left"/>
    <strong class="desc">Title: <span id="name"></span></strong>
    <strong class="desc"><br />Release Year: <span id="year"></span></strong>
    <strong class="desc"><br />Director: <span id="director"></span></strong>
    <strong class="desc"><br />Genre: <span id="genre"></span></strong>
    <strong class="desc"><br />Average Rating: <span id="rating"></span></strong>
    <strong class="desc"><br />Synopsis: <span id="synopsis"></span></strong>
    </div>

    <script type="text/javascript">
        $(document).ready(function () {
            // initializing our data source and storing the jquery elements corresponding to movie info
            var data_url = "http://odata.netflix.com/Catalog/Titles?$format=json&$callback=?";
            var jsonp = new $.ig.JSONPDataSource({ dataSource: data_url, responseDataKey: "d.results" });
            var boxart = $("#boxArt");
            var title = $("#name"); var year = $("#year");
            var director = $("#director"); var genre = $("#genre");
            var avg_rating = $("#rating");

            // this is the NetFlix query we're using to get info for selected movies
            function movieQuery(movie) {
                return "http://odata.netflix.com/Catalog"
            + "/Titles"
            + "?$filter=substringof('" + escape(movie) + "',Name)"
            + "&$callback=?" // take note that we need the callback property specified
            + "&$expand=Directors,Genres"
            + "&$format=json";
            }

            var grid = $("#gridTarget");
            grid.igGrid({
                autoGenerateColumns: false,
                width: 400,
                dataSource: jsonp,
                columns: [
                    { headerText: "Movie Name", key: "Name" }
                ], features: [
                    { name: "Paging", pageSize: 10 },
                    { name: "Selection", mode: "cell",
                        cellSelectionChanged: function (evt, ui) {
                            var movie_name = ui.cell.element.text(); // getting the text of the selected cell
                            $.ajax({
                                dataType: "jsonp",
                                url: movieQuery(movie_name), // building our netflix query with the selected movie's name
                                success: results
                            });
                        }
                    }
                ]
            });

            // getting to the result data
            function results(data) {

                var info = data["d"]["results"];
                if (info.length == 0) alert("No information available !"); // if there is no info for a movie, we don't want any of the code to be executed
                else 
                {
                    // we apply the boxart url location to the src of our image
                    boxart.attr("src", info[0].BoxArt.LargeUrl);
                    // and we display additional info for the movie
                    $(".desc").show();
                    $("#synopsis").text(info[0].Synopsis);

                    title.text(info[0].ShortName);

                    // since some movies may have no info about their director, we want to hide this field if it's empty
                    if (info[0].Directors.results.length == 0) {
                        director.parent().hide();
                    }
                    else
                    {
                        director.text(info[0].Directors.results[0].Name);
                    }

                    year.text(info[0].ReleaseYear);

                    // here we collect all the genres so we can display them in one go
                    var arr = [];
                    $.each(info[0].Genres.results, function () {
                        arr.push(this.Name);
                    });
                    genre.text(arr.join(", "));

                    avg_rating.text(info[0].AverageRating + " / 5");
                }

            }
        });
    </script>
</asp:Content>
