﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Site.Master" AutoEventWireup="true" CodeBehind="Default2.aspx.cs" Inherits="igGridRowSelectors.Default2" %>
<asp:Content ID="Content1" ContentPlaceHolderID="HeadContent" runat="server">
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
<div id="gridHolder">
    <table id="gridTarget"></table>
    </div>

    <div id="holder">
    <p>Selected row: <label id="rowNumber"></label></p>
    <p id="info"></p>
    </div>

    <script type="text/javascript">
        $(document).ready(function () {
            // initializing our data source
            var data_url = "http://odata.netflix.com/Catalog/Titles?$format=json&$callback=?";
            var jsonp = new $.ig.JSONPDataSource({ dataSource: data_url, responseDataKey: "d.results" });

            var grid = $("#gridTarget");
            grid.igGrid({
                autoGenerateColumns: false,
                width: 600,
                dataSource: jsonp,
                columns: [
                    { headerText: "Movie Name", key: "Name" },
                    { headerText: "Release Year", key: "ReleaseYear" },
                    { headerText: "Average Rating", key: "AverageRating" }
                ],
                features: [
                    { name: "Paging", pageSize: 10 },
                    { name: "RowSelectors", rowSelectorClicked: function (evt, ui) {
                        $("#info").empty(); // we reset the info area so we can render new information in it
                        $("#rowNumber").text(ui.rowIndex + 1);
                        var rowContents = ui.row.find("td"); // here we drill to all the table data elements within the selected row
                        var cols = getHeaders();
                        $.each(cols, function (i) {
                            $("#info").append("<b>" + cols[i] + " : </b>" + rowContents[i].innerHTML + "<br />");
                        });
                    }
                    }
                ]
            });

            // this function is used to get all the column headers so we can use them outside of the grid
            function getHeaders() {
                var headers = $("#gridTarget").igGrid("headersTable").find("thead tr th");
                var columns = [];
                $.each(headers, function () {
                    var current = $(this).find("span").text();
                    if (current.length != 0) columns.push(current);
                });
                return columns;
            }
        });
    </script>
</asp:Content>
